<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <!-- Popper Development version -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css" />
    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container mt-4">
        <h2 class="text-center">F200 - LỊCH SỬ VOUCHER</h2>

        <div class="row jumbotron p-3 m-0">
            <div class="row form-group mb-0">
                <div class="col-md-12">
                    <form action="">
                        <div class="form-row">
                            <h5>Thông tin người chơi</h5>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-4">
                                <label for="">Username</label>
                                <input type="text" name="" id="user-name" class="form-control bg-secondary text-white"
                                    disabled />
                            </div>

                            <div class="form-group col-md-4">
                                <label for="">First Name</label>
                                <input type="text" name="" id="first-name" class="form-control bg-secondary text-white"
                                    disabled />
                            </div>

                            <div class="form-group col-md-4">
                                <label for="">Last Name</label>
                                <input type="text" name="" id="last-name" class="form-control bg-secondary text-white"
                                    disabled />
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>

        <div id="log-result" class="mt-5"></div>

        <div class="mt-5">
            <table id="table-voucher-history" class="table table-bordered table-striped table-hover">
                <thead class="thead-dark">
                    <tr>
                        <th scope="col">STT</th>
                        <th scope="col">Mã voucher</th>
                        <th scope="col">Phần trăm giảm giá</th>
                        <th scope="col">Ngày tạo</th>
                    </tr>
                </thead>
                <tbody></tbody>
            </table>
        </div>
    </div>

    <script>
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
        var gPlayerInfoObj = {};
        var gVoucherHistoryData = [];

        var gNameCol = ["stt", "maVoucher", "phanTramGiamGia", "ngayTao"];
        const gSTT_COL = 0;
        const gMA_VOUCHER_COL = 1;
        const gPHAN_TRAM_GG_COL = 2;
        const gNGAY_TAO_COL = 3;

        var gVoucherDataTable = $("#table-voucher-history").DataTable({
            columns: [
                { data: gNameCol[gSTT_COL] },
                { data: gNameCol[gMA_VOUCHER_COL] },
                { data: gNameCol[gPHAN_TRAM_GG_COL] },
                { data: gNameCol[gNGAY_TAO_COL] },
            ],
            columnDefs: [
                {
                    targets: gSTT_COL,
                    className: "text-center text-primary",
                    render: function (data, type, row, meta) {
                        return meta.row + meta.settings._iDisplayStart + 1;
                    },
                },
                {
                    targets: gPHAN_TRAM_GG_COL,
                    className: "text-center text-success",
                },
            ],
        });
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        onPageLoading();
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //hàm thực thi khi tải trang
        function onPageLoading() {
            var vCurrentUrl = window.location.href;
            catchDataFromUrl(vCurrentUrl);
            loadPlayerInfoToForm();
            getVoucherHistory(gPlayerInfoObj.userName);
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm lấy dữ liệu từ url
        function catchDataFromUrl(paramCurrentUrl) {
            var vNewUrl = new URL(paramCurrentUrl);

            var vUsername = vNewUrl.searchParams.get("user_name");
            var vFirstname = vNewUrl.searchParams.get("first_name");
            var vLastname = vNewUrl.searchParams.get("last_name");

            gPlayerInfoObj.userName = vUsername;
            gPlayerInfoObj.firstName = vFirstname;
            gPlayerInfoObj.lastName = vLastname;

            console.log(gPlayerInfoObj);
        }

        //hàm load thông tin người chơi lên web
        function loadPlayerInfoToForm() {
            $("#user-name").val(gPlayerInfoObj.userName);
            $("#first-name").val(gPlayerInfoObj.firstName);
            $("#last-name").val(gPlayerInfoObj.lastName);
        }

        //hàm lấy voucher history và xử lý hiển thị
        function getVoucherHistory(paramUserName) {
            $.ajax({
                url: gBASE_URL + "/voucher-history?username=" + paramUserName,
                type: "GET",
                success: function (res) {
                    console.log(res);
                    if (res.vouchers.length > 0) {
                        var vCount = 0;
                        while (vCount < res.vouchers.length) {
                            var bVoucher = {
                                maVoucher: res.vouchers[vCount].maVoucher,
                                phanTramGiamGia: res.vouchers[vCount].phanTramGiamGia,
                                ngayTao: res.vouchers[vCount].ngayTao,
                            };
                            gVoucherHistoryData.push(bVoucher);
                            vCount++;
                        }
                        loadDataToVoucherTable();
                    }
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText);
                },
            });
        }

        //hàm load voucher history lên table
        function loadDataToVoucherTable() {
            gVoucherDataTable.clear();
            gVoucherDataTable.rows.add(gVoucherHistoryData);
            gVoucherDataTable.draw();
        }
    </script>
</body>

</html>